Index: admin/js/_post.js
===================================================================
--- admin/js/_post.js	(revision 2614)
+++ admin/js/_post.js	(revision 2556)
@@ -51,4 +51,36 @@
 
 $(function() {
+	if (!document.getElementById) { return; }
+
+	if (document.getElementById('edit-entry'))
+	{
+		// Get document format and prepare toolbars
+		var formatField = $('#post_format').get(0);
+		var last_post_format = $(formatField).val();
+		$(formatField).change(function() {
+			// Confirm post format change
+			if(window.confirm(dotclear.msg.confirm_change_post_format_noconvert)){
+				excerptTb.switchMode(this.value);
+				contentTb.switchMode(this.value);
+				last_post_format = $(this).val();
+			}else{
+				// Restore last format if change cancelled
+				$(this).val(last_post_format);
+			}
+
+			$('.format_control > *').addClass('hide');
+			$('.format_control:not(.control_no_'+$(this).val()+') > *').removeClass('hide');
+		});
+
+		var excerptTb = new jsToolBar(document.getElementById('post_excerpt'));
+		var contentTb = new jsToolBar(document.getElementById('post_content'));
+		excerptTb.context = contentTb.context = 'post';
+	}
+
+	if (document.getElementById('comment_content')) {
+		var commentTb = new jsToolBar(document.getElementById('comment_content'));
+		commentTb.draw('xhtml');
+	}
+
 	// Post preview
 	$('#post-preview').modalWeb($(window).width()-40,$(window).height()-40);
@@ -67,4 +99,72 @@
 			return window.confirm(dotclear.msg.confirm_delete_post);
 		});
+
+		// Markup validator
+		var v = $('<div class="format_control"><p><a id="a-validator"></a></p><div/>').get(0);
+		$('.format_control').before(v);
+		var a = $('#a-validator').get(0);
+		a.href = '#';
+		a.className = 'button ';
+		$(a).click(function() {
+
+			excerpt_content = $('#post_excerpt').css('display') != 'none' ? $('#post_excerpt').val() : $('#excerpt-area iframe').contents().find('body').html();
+			post_content	= $('#post_content').css('display') != 'none' ? $('#post_content').val() : $('#content-area iframe').contents().find('body').html();
+
+			var params = {
+				xd_check: dotclear.nonce,
+				f: 'validatePostMarkup',
+				excerpt: excerpt_content,
+				content: post_content,
+				format: $('#post_format').get(0).value,
+				lang: $('#post_lang').get(0).value
+			};
+
+			$.post('services.php',params,function(data) {
+				if ($(data).find('rsp').attr('status') != 'ok') {
+					alert($(data).find('rsp message').text());
+					return false;
+				}
+
+				$('.message, .success, .error, .warning-msg').remove();
+
+				if ($(data).find('valid').text() == 1) {
+					var p = document.createElement('p');
+					p.id = 'markup-validator';
+
+					$(p).addClass('success');
+					$(p).text(dotclear.msg.xhtml_valid);
+					$('#entry-content h3').after(p);
+					$(p).backgroundFade({sColor: dotclear.fadeColor.beginValidatorMsg, eColor: dotclear.fadeColor.endValidatorMsg, steps: 50},function() {
+							$(this).backgroundFade({sColor: dotclear.fadeColor.endValidatorMsg, eColor: dotclear.fadeColor.beginValidatorMsg});
+					});
+				} else {
+					var div = document.createElement('div');
+					div.id = 'markup-validator';
+
+					$(div).addClass('error');
+					$(div).html('<p><strong>' + dotclear.msg.xhtml_not_valid + '</strong></p>' + $(data).find('errors').text());
+					$('#entry-content h3').after(div);
+					$(div).backgroundFade({sColor: dotclear.fadeColor.beginValidatorErr,eColor: dotclear.fadeColor.endValidatorErr, steps: 50},function() {
+							$(this).backgroundFade({sColor: dotclear.fadeColor.endValidatorErr, eColor: dotclear.fadeColor.beginValidatorErr});
+					});
+				}
+
+				if ( $('#post_excerpt').text() != excerpt_content || $('#post_content').text() != post_content ) {
+					var pn = document.createElement('p');
+					$(pn).addClass('warning-msg');
+					$(pn).text(dotclear.msg.warning_validate_no_save_content);
+					$('#entry-content h3').after(pn);
+				}
+
+				return false;
+			});
+
+			return false;
+		});
+
+		a.appendChild(document.createTextNode(dotclear.msg.xhtml_validator));
+
+		$('.format_control > *').addClass('hide');
+		$('.format_control:not(.control_no_'+last_post_format+') > *').removeClass('hide');
 
 		// Hide some fields
@@ -117,4 +217,8 @@
 			hide: $('#post_excerpt').val() == ''
 		});
+
+		// Load toolbars
+		contentTb.switchMode(formatField.value);
+		excerptTb.switchMode(formatField.value);
 
 		// Replace attachment remove links by a POST form submit
@@ -129,4 +233,13 @@
 			return false;
 		});
+
+		// Check unsaved changes before XHTML conversion
+		var excerpt = $('#post_excerpt').val();
+		var content = $('#post_content').val();
+		$('#convert-xhtml').click(function() {
+			if (excerpt != $('#post_excerpt').val() || content != $('#post_content').val()) {
+				return window.confirm(dotclear.msg.confirm_change_post_format);
+			}
+		});
 	});
 
Index: admin/js/_preferences.js
===================================================================
--- admin/js/_preferences.js	(revision 2679)
+++ admin/js/_preferences.js	(revision 2566)
@@ -20,17 +20,3 @@
 		return true;
 	});
-
-	// choose format depending of editor based on formats_by_editor defined in preferences.php
-	if (formats_by_editor !== undefined) {
-		var _editors = $.parseJSON(formats_by_editor);
-	
-		$('#user_editor').change(function() {
-			if (!_editors[$(this).val()]) {return;}
-			
-			$('#user_post_format option').remove();
-			for (var format in _editors[$(this).val()]) {
-				$('#user_post_format').append('<option value="'+format+'">'+format+'</option>');
-			}
-		});
-	}
 });
Index: admin/js/common.js
===================================================================
--- admin/js/common.js	(revision 2689)
+++ admin/js/common.js	(revision 2566)
@@ -290,5 +290,5 @@
 	var peInPage = $('#help-button').offset().top;
 	$('#help-button').addClass("floatable");
-	var peInFloat = $('#help-button').offset().top - $(window).scrollTop();
+	var peInFloat = $('#help-button').offset().top;
 	$('#help-button').removeClass("floatable");
 	$(window).scroll(
Index: admin/js/jsToolBar/jsToolBar.dotclear.js
===================================================================
--- admin/js/jsToolBar/jsToolBar.dotclear.js	(revision 2566)
+++ admin/js/jsToolBar/jsToolBar.dotclear.js	(revision 2566)
@@ -0,0 +1,386 @@
+/* Change link button actions
+-------------------------------------------------------- */
+jsToolBar.prototype.elements.link.data = {};
+jsToolBar.prototype.elements.link.fncall = {};
+jsToolBar.prototype.elements.link.open_url = 'popup_link.php';
+
+jsToolBar.prototype.elements.link.popup = function (args) {
+	window.the_toolbar = this;
+	args = args || '';
+
+	this.elements.link.data = {};
+	var url = this.elements.link.open_url+args;
+
+	var p_win = window.open(url,'dc_popup',
+	'alwaysRaised=yes,dependent=yes,toolbar=yes,height=420,width=520,'+
+	'menubar=no,resizable=yes,scrollbars=yes,status=no');
+};
+
+jsToolBar.prototype.elements.link.fn.wiki = function() {
+	this.elements.link.popup.call(this,'?hreflang='+this.elements.link.default_hreflang);
+};
+jsToolBar.prototype.elements.link.fncall.wiki = function() {
+	var data = this.elements.link.data;
+
+	if (data.href == '') { return; }
+
+	var etag = '|'+data.href;
+	if (data.hreflang) { etag += '|'+data.hreflang; }
+
+	if (data.title) {
+		if (!data.hreflang) { etag += '|'; }
+		etag += '|'+data.title;
+	}
+
+	if (data.content) {
+		this.encloseSelection('['+data.content,etag+']');
+	} else {
+		this.encloseSelection('[',etag+']');
+	}
+};
+
+jsToolBar.prototype.elements.link.fn.xhtml = function() {
+	this.elements.link.popup.call(this,'?hreflang='+this.elements.link.default_hreflang);
+};
+jsToolBar.prototype.elements.link.fncall.xhtml = function() {
+	var data = this.elements.link.data;
+
+	if (data.href == '') { return; }
+
+	var stag = '<a href="'+data.href+'"';
+
+	if (data.hreflang) { stag += ' hreflang="'+data.hreflang+'"'; }
+	if (data.title) { stag += ' title="'+data.title+'"'; }
+	stag += '>';
+	var etag = '</a>';
+
+	if (data.content) {
+		this.encloseSelection('','',function() {
+			return stag + data.content + etag;
+		});
+	} else {
+		this.encloseSelection(stag,etag);
+	}
+};
+
+jsToolBar.prototype.elements.link.fn.wysiwyg = function() {
+	var href, title, hreflang;
+	href = title = hreflang = '';
+	hreflang = this.elements.link.default_hreflang;
+
+	var a = this.getAncestor();
+
+	if (a.tagName == 'a') {
+		href= a.tag.href || '';
+		title = a.tag.title || '';
+		hreflang = a.tag.hreflang || '';
+	}
+
+	this.elements.link.popup.call(this,'?href='+href+'&hreflang='+hreflang+'&title='+title);
+};
+jsToolBar.prototype.elements.link.fncall.wysiwyg = function() {
+	var data = this.elements.link.data;
+
+	var a = this.getAncestor();
+
+	if (a.tagName == 'a') {
+		if (data.href == '') {
+			// Remove link
+			this.replaceNodeByContent(a.tag);
+			this.iwin.focus();
+			return;
+		} else {
+			// Update link
+			a.tag.href = data.href;
+			if (data.hreflang) {
+				a.tag.setAttribute('hreflang',data.hreflang);
+			} else {
+				a.tag.removeAttribute('hreflang');
+			}
+			if (data.title) {
+				a.tag.setAttribute('title',data.title);
+			} else {
+				a.tag.removeAttribute('title');
+			}
+			return;
+		}
+	}
+
+	// Create link
+	if (data.content) {
+		var n = document.createTextNode(data.content);
+	} else {
+		var n = this.getSelectedNode();
+	}
+	var a = this.iwin.document.createElement('a');
+	a.href = data.href;
+	if (data.hreflang) a.setAttribute('hreflang',data.hreflang);
+	if (data.title) a.setAttribute('title',data.title);
+	a.appendChild(n);
+	this.insertNode(a);
+};
+jsToolBar.prototype.getAncestor = function() {
+	var res = {};
+	var range, commonAncestorContainer;
+
+	if (this.iwin.getSelection) { //gecko
+		var selection = this.iwin.getSelection();
+		range = selection.getRangeAt(0);
+		commonAncestorContainer = range.commonAncestorContainer;
+		while (commonAncestorContainer.nodeType != 1) {
+			commonAncestorContainer = commonAncestorContainer.parentNode;
+		}
+	} else { //ie
+		range = this.iwin.document.selection.createRange();
+		commonAncestorContainer = range.parentElement();
+	}
+
+	var ancestorTagName = commonAncestorContainer.tagName.toLowerCase();
+	while (ancestorTagName!='a' && ancestorTagName!='body') {
+		commonAncestorContainer = commonAncestorContainer.parentNode;
+		ancestorTagName = commonAncestorContainer.tagName.toLowerCase();
+	}
+
+	res.tag = commonAncestorContainer;
+	res.tagName = ancestorTagName;
+
+	return res;
+};
+
+/* Image selector
+-------------------------------------------------------- */
+jsToolBar.prototype.elements.img_select = {
+	type: 'button',
+	title: 'Image chooser',
+	fn: {},
+	fncall: {},
+	open_url: 'media.php?popup=1',
+	data: {},
+	popup: function() {
+		window.the_toolbar = this;
+		this.elements.img_select.data = {};
+
+		var p_win = window.open(this.elements.img_select.open_url,'dc_popup',
+		'alwaysRaised=yes,dependent=yes,toolbar=yes,height=500,width=760,'+
+		'menubar=no,resizable=yes,scrollbars=yes,status=no');
+	}
+};
+jsToolBar.prototype.elements.img_select.fn.wiki = function() {
+	this.elements.img_select.popup.call(this);
+};
+jsToolBar.prototype.elements.img_select.fncall.wiki = function() {
+	var d = this.elements.img_select.data;
+	if (d.src == undefined) { return; }
+
+	this.encloseSelection('','',function(str) {
+		var alt = (str) ? str : d.title;
+		var res = '(('+d.src+'|'+alt;
+
+		if (d.alignment == 'left') {
+			res += '|L';
+		} else if (d.alignment == 'right') {
+			res += '|R';
+		} else if (d.alignment == 'center') {
+			res += '|C';
+		} else if (d.description) {
+			res += '|';
+		}
+
+		if (d.description) {
+			res += '|'+d.description;
+		}
+
+		res += '))';
+
+		if (d.link) {
+			var ltitle = (alt) ? '||'+alt : '';
+			res = '['+res+'|'+d.url+ltitle+']';
+		}
+
+		return res;
+	});
+};
+jsToolBar.prototype.elements.img_select.fn.xhtml = function() {
+	this.elements.img_select.popup.call(this);
+};
+jsToolBar.prototype.elements.img_select.fncall.xhtml = function() {
+	var d = this.elements.img_select.data;
+	if (d.src == undefined) { return; }
+
+	this.encloseSelection('','',function(str) {
+		var alt = (str) ? str : d.title;
+		var res = '<img src="'+d.src+'" alt="'+alt.replace('&','&amp;').replace('>','&gt;').replace('<','&lt;').replace('"','&quot;')+'"';
+
+		if (d.alignment == 'left') {
+			res += ' style="float: left; margin: 0 1em 1em 0;"';
+		} else if (d.alignment == 'right') {
+			res += ' style="float: right; margin: 0 0 1em 1em;"';
+		} else if (d.alignment == 'center') {
+			res += ' style="margin: 0 auto; display: block;"';
+		}
+
+		if (d.description) {
+			res += ' title="'+d.description.replace('&','&amp;').replace('>','&gt;').replace('<','&lt;').replace('"','&quot;')+'"';
+		}
+
+		res += ' />';
+
+		if (d.link) {
+			var ltitle = (alt) ? ' title="'+alt.replace('&','&amp;').replace('>','&gt;').replace('<','&lt;').replace('"','&quot;')+'"' : '';
+			res = '<a href="'+d.url+'"'+ltitle+'>'+res+'</a>';
+		}
+
+		return res;
+	});
+};
+
+jsToolBar.prototype.elements.img.fn.wysiwyg = function() {
+	var src = this.elements.img.prompt.call(this);
+	if (!src) { return; }
+
+	var img = this.iwin.document.createElement('img');
+	img.src = src;
+	img.setAttribute('alt',this.getSelectedText());
+
+	this.insertNode(img);
+};
+
+jsToolBar.prototype.elements.img_select.fn.wysiwyg = function() {
+	this.elements.img_select.popup.call(this);
+};
+jsToolBar.prototype.elements.img_select.fncall.wysiwyg = function() {
+	var d = this.elements.img_select.data;
+	var alt = (this.getSelectedText()) ? this.getSelectedText() : d.title;
+	if (d.src == undefined) { return; }
+
+	var img = this.iwin.document.createElement('img');
+	img.src = d.src;
+	img.setAttribute('alt',alt);
+
+
+	if (d.alignment == 'left') {
+		if (img.style.styleFloat != undefined) {
+			img.style.styleFloat = 'left';
+		} else {
+			img.style.cssFloat = 'left';
+		}
+		img.style.marginTop = 0;
+		img.style.marginRight = '1em';
+		img.style.marginBottom = '1em';
+		img.style.marginLeft = 0;
+	} else if (d.alignment == 'right') {
+		if (img.style.styleFloat != undefined) {
+			img.style.styleFloat = 'right';
+		} else {
+			img.style.cssFloat = 'right';
+		}
+		img.style.marginTop = 0;
+		img.style.marginRight = 0;
+		img.style.marginBottom = '1em';
+		img.style.marginLeft = '1em';
+	} else if (d.alignment == 'center') {
+		img.style.marginTop = 0;
+		img.style.marginRight = 'auto';
+		img.style.marginBottom = 0;
+		img.style.marginLeft = 'auto';
+		img.style.display = 'block';
+	}
+
+	if (d.description) {
+		img.setAttribute('title',d.description);
+	}
+
+	if (d.link) {
+		var a = this.iwin.document.createElement('a');
+		a.href = d.url;
+		if (alt) {
+			a.setAttribute('title',alt);
+		}
+		a.appendChild(img);
+		this.insertNode(a);
+	} else {
+		this.insertNode(img);
+	}
+};
+
+// MP3 helpers
+jsToolBar.prototype.elements.mp3_insert = { fncall: {}, data: {} };
+jsToolBar.prototype.elements.mp3_insert.fncall.wiki = function() {
+	var d = this.elements.mp3_insert.data;
+	if (d.player == undefined) { return; }
+
+	this.encloseSelection('','',function(str) {
+		return '\n///html\n' + d.player + '///\n';
+	});
+};
+jsToolBar.prototype.elements.mp3_insert.fncall.xhtml = function() {
+	var d = this.elements.mp3_insert.data;
+	if (d.player == undefined) { return; }
+
+	this.encloseSelection('','',function(str) {
+		return '\n' + d.player + '\n';
+	});
+};
+jsToolBar.prototype.elements.mp3_insert.fncall.wysiwyg = function() {
+	return;
+};
+
+// FLV helpers
+jsToolBar.prototype.elements.flv_insert = { fncall: {}, data: {} };
+jsToolBar.prototype.elements.flv_insert.fncall.wiki = function() {
+	var d = this.elements.flv_insert.data;
+	if (d.player == undefined) { return; }
+
+	this.encloseSelection('','',function(str) {
+		return '\n///html\n' + d.player + '///\n';
+	});
+};
+jsToolBar.prototype.elements.flv_insert.fncall.xhtml = function() {
+	var d = this.elements.flv_insert.data;
+	if (d.player == undefined) { return; }
+
+	this.encloseSelection('','',function(str) {
+		return '\n' + d.player + '\n';
+	});
+};
+jsToolBar.prototype.elements.flv_insert.fncall.wysiwyg = function() {
+	return;
+};
+
+
+/* Posts selector
+-------------------------------------------------------- */
+jsToolBar.prototype.elements.post_link = {
+	type: 'button',
+	title: 'Link to an entry',
+	fn: {},
+	open_url: 'popup_posts.php',
+	data: {},
+	popup: function() {
+		window.the_toolbar = this;
+		this.elements.img_select.data = {};
+
+		var p_win = window.open(this.elements.post_link.open_url,'dc_popup',
+		'alwaysRaised=yes,dependent=yes,toolbar=yes,height=500,width=760,'+
+		'menubar=no,resizable=yes,scrollbars=yes,status=no');
+	}
+};
+jsToolBar.prototype.elements.post_link.fn.wiki = function() {
+	this.elements.post_link.popup.call(this);
+};
+jsToolBar.prototype.elements.post_link.fn.xhtml = function() {
+	this.elements.post_link.popup.call(this);
+};
+jsToolBar.prototype.elements.post_link.fn.wysiwyg = function() {
+	this.elements.post_link.popup.call(this);
+};
+
+// Last space element
+jsToolBar.prototype.elements.space3 = {
+	type:'space',
+	format:{
+		wysiwyg:true,
+		wiki:true,
+		xhtml:true
+	}
+};
